/*
   Aug 2001 adapted by T. Verelst, theover@yahoo.com 
                                   http://theover.tripod.com
   to act as graphics interface for string simulator program
   permission to use and distribute for non-commercial 
   applications, under condition of including all provided 
   information including this notice.
*/


/*
 * Copyright (c) 1993-1997, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED 
 * Permission to use, copy, modify, and distribute this software for 
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that 
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission. 
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * US Government Users Restricted Rights 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(R) is a registered trademark of Silicon Graphics, Inc.
 */

/*
 * pickdepth.c
 * Picking is demonstrated in this program.  In 
 * rendering mode, three overlapping rectangles are 
 * drawn.  When the left mouse button is pressed, 
 * selection mode is entered with the picking matrix.  
 * Rectangles which are drawn under the cursor position
 * are "picked."  Pay special attention to the depth 
 * value range, which is returned.
 */
#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>

GLfloat ar=1.0;
extern int volume;
int updatecount;

void volumechangedupdate(i)
int i;
{
printf ("*");
fflush(stdout);
   glutPostRedisplay();
   updatecount--;
}

void volumechanged()
{
   return;
printf ("#");
/*   display();  */
   glutPostRedisplay();
   glutTimerFunc(50, volumechangedupdate, 0);
   updatecount = 3;
/*   glFinish();  */
}

void pickinit(void)
{
   GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };
   GLfloat diffuse[] = { 0.2, 1.0, 0.3, 1.0 };
   GLfloat lmodel_ambient[] = { 0.3, 0.3, 0.3, 0.0 };

   glClearColor(0.0, 0.0, 0.0, 0.0);
   glShadeModel (GL_SMOOTH);

   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);

   glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
   glLightfv(GL_LIGHT0, GL_POSITION, light_position);
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   glEnable(GL_DEPTH_TEST);
/*   glShadeModel(GL_FLAT); */
   glDepthRange(0.0, 1.0);  /* The default z mapping */
}

void rotview()
{
   glTranslatef (0.0, 0.0, 3.0);
   glRotatef (-5.0, 10.0, 0.0, 1.0);
   glTranslatef (0.0, 0.0, -3.0);
}


/* The three rectangles are drawn.  In selection mode, 
 * each rectangle is given the same name.  Note that 
 * each rectangle is drawn with a different z value.
 */
void drawRects(GLenum mode)
{
   GLfloat no_mat[] = { 0.2, 0.2, 0.2, 1.0 };
   GLfloat mat_diffuse[] = { 0.9, 0.5, 0.8, 1.0 };

   glPushMatrix();
   if (mode == GL_SELECT)
      glLoadName(1);
   rotview();
   glColor3f(1.0, 0.6, 0.6);
   /* glRotatef (20.0, 10.0, -30.0, 0.0); */
   glRotatef (20.0, (GLfloat) volume, -30.0, 0.0);
   glTranslatef (0.1, 0.2, -1.5);
   glScalef (0.003, 0.003, 0.003);
   glutStrokeCharacter(GLUT_STROKE_ROMAN,(int) 'a');
   glutStrokeCharacter(GLUT_STROKE_ROMAN,(int) 'Z');
   glutStrokeCharacter(GLUT_STROKE_ROMAN,(int) ' ');
   glutStrokeCharacter(GLUT_STROKE_ROMAN,(int) '@');
   glPopMatrix();

   glPushMatrix();
   rotview();
   if (mode == GL_SELECT)
      glLoadName(2);
   glScalef (1.0, 1.0, 1.0);
   glTranslatef (0.0,  0.0,  -2.0);
   glutWireCube (1.0);
   glTranslatef (-1.5,  -0.5,  -2.0);
   glutSolidCube (2.0);
   glPopMatrix();

   glPushMatrix();
   rotview();
   if (mode == GL_SELECT)
      glLoadName(0);

   glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);
   glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);

   glScalef (1.0, 1.0, 1.0);
   glTranslatef (+1.5,  -0.5,  -2.0);
   glutSolidTorus((GLdouble) 1.0/4,(GLdouble)  2.0/4, 16, 16);
   glPopMatrix();

if (0) {   if (mode == GL_SELECT)
      glLoadName(1);
   glBegin(GL_QUADS);
   glColor3f(1.0, 1.0, 0.0);
   glVertex3i(2, 0, 0);
   glVertex3i(2, 6, 0);
   glVertex3i(6, 6, 0);
   glVertex3i(6, 0, 0);
   glEnd();
   if (mode == GL_SELECT)
      glLoadName(2);
   glBegin(GL_QUADS);
   glColor3f(0.0, 1.0, 1.0);
   glVertex3i(3, 2, -1);
   glVertex3i(3, 8, -1);
   glVertex3i(8, 8, -1);
   glVertex3i(8, 2, -1);
   glEnd();
}
   if (mode == GL_SELECT)
      glLoadName(3);
   glBegin(GL_QUADS);
   glColor3f(1.0, 0.0, 1.0);
   glVertex3i(0, 2, -3);
   glVertex3i(0, 7, -3);
   glVertex3i(5, 7, -3);
   glVertex3i(5, 2, -3);
   glEnd();
}

/*  processHits() prints out the contents of the 
 *  selection array.
 */
void processHits(GLint hits, GLuint buffer[])
{
   unsigned int i, j;
   GLuint names, *ptr;

   printf("hits = %d\n", hits);
   ptr = (GLuint *) buffer;
   for (i = 0; i < hits; i++) {  /* for each hit  */
      names = *ptr;
      printf(" number of names for hit = %d\n", names); ptr++;
      printf("  z1 is %g;", (float) *ptr/0x7fffffff); ptr++;
      printf(" z2 is %g\n", (float) *ptr/0x7fffffff); ptr++;
      printf("   the name is ");
      for (j = 0; j < names; j++) {  /* for each name */
         pms_do(*ptr);
         printf("%d ", *ptr); ptr++;
      }
      printf("\n");
   }
}

/*  pickRects() sets up selection mode, name stack, 
 *  and projection matrix for picking.  Then the objects 
 *  are drawn.
 */
#define BUFSIZE 512


void pickRects(int button, int state, int x, int y)
{
   GLuint selectBuf[BUFSIZE];
   GLint hits;
   GLint viewport[4];

   if (button != GLUT_LEFT_BUTTON || state != GLUT_DOWN)
      return;

   glGetIntegerv(GL_VIEWPORT, viewport);

   glSelectBuffer(BUFSIZE, selectBuf);
   (void) glRenderMode(GL_SELECT);

   glInitNames();
   glPushName(0);

   glMatrixMode(GL_PROJECTION);
   glPushMatrix();
   glLoadIdentity();
/*  create 5x5 pixel picking region near cursor location */
   gluPickMatrix((GLdouble) x, (GLdouble) (viewport[3] - y),
                 5.0, 5.0, viewport);
   /* glOrtho(0.0, 8.0, 0.0, 8.0, -0.5, 2.5); */
   gluPerspective(90.0f, ar,0.1f,100.0f);
   drawRects(GL_SELECT);
   glPopMatrix();
   glFlush();

   hits = glRenderMode(GL_RENDER);
   processHits(hits, selectBuf);
}

void display(void)
{
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   drawRects(GL_RENDER);
/*      glutStrokeCharacter(GLUT_STROKE_ROMAN,(int) 'Z'); */
   glFlush();
}

void reshape(int w, int h)
{
   glViewport(0, 0, (GLsizei) w, (GLsizei) h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   /* glOrtho(0.0, 8.0, 0.0, 8.0, -0.5, 2.5); */
   ar = (GLfloat)w/(GLfloat)h;
   gluPerspective(90.0f, ar ,0.1f,100.0f);
   

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
}

void keyboard(unsigned char key, int x, int y)
{
   if (key >= '0' && key <= '9') {
      pms_do((int) key-  '0');
      return;
   }
   if ((key >= 'a' && key <= 'z') || (key >= 'A' && key <= 'Z')) {
      glutStrokeCharacter(GLUT_STROKE_ROMAN,(int) key);
      glutSetCursor(GLUT_CURSOR_SPRAY);
      return;
   }
   switch (key) {
      case 27:
	 pick_end();
         exit(0);
         break;
      case '0':
         pms_do(0);
         break;
      case '1':
         pms_do(1);
         break;
      case '2':
         pms_do(2);
         break;
      case '3':
         pms_do(3);
         break;
   }
}

#define M_SOUND1 1
#define M_EXIT 2
#define M_CURSORCHANGE 3

static void
rightmenu(int value)
{
  switch (value) {
  case M_SOUND1:
    printf("sound 1\n");
    pms_do(1);
    return;
  case M_EXIT:
    pick_end();
    exit(0);
    return;
  case M_CURSORCHANGE:
    glutSetCursor(GLUT_CURSOR_CYCLE);
    return;
  }
}

void pickcreatemenu()
{
  glutCreateMenu(rightmenu);

  glutAddMenuEntry("Sound 1", M_SOUND1);
  glutAddMenuEntry(" Change cursor ",M_CURSORCHANGE);
  glutAddMenuEntry("Exit", M_EXIT);
  glutAttachMenu(GLUT_RIGHT_BUTTON);

}


/*  Main Loop
 */
int pick_main(int *argc, char **argv)
{
   glutInit(argc, argv);
   glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB | GLUT_DEPTH);
   glutInitWindowSize (200, 200);
   glutInitWindowPosition (400, 100);
   glutCreateWindow(argv[0]);
   pickcreatemenu();
   pickinit();
   glutReshapeFunc(reshape);
   glutDisplayFunc(display);
   glutMouseFunc(pickRects);
   glutKeyboardFunc(keyboard);
   return 0;
}
pick_loop()
{
   glutMainLoop();
}

pick_end()                     /* Close soundstream and prepare to quit */
{
   pa_maine();
   closeup();
   printf("Called pick_end.\n");
}
